<template>
  <b-col :sm="size">
    <b-card @dragenter="dragenter" @dragover="dragover" @drop="onDrop">
      <b-card-title :class="isCollapsed ? 'isCollapsedTitle' : ''">{{
        title
      }}</b-card-title>
      <b-button
        variant="outline-secondary"
        class="compact-toggle"
        @click="isCollapsing"
      >
        <i-bi-chevron-down v-if="!isCollapsed" />
        <i-bi-chevron-right v-if="isCollapsed" />
      </b-button>
      <slot v-if="!isCollapsed"></slot>
    </b-card>
  </b-col>
</template>

<script lang="ts">
import { defineComponent } from "vue";

export default defineComponent({
  name: "AimsCollapsibleColumn",
  props: {
    droppable: {
      default: false,
      type: Boolean,
    },
    isCollapsed: {
      required: true,
      type: Boolean,
    },
    size: {
      required: true,
      type: Number,
    },
    title: {
      required: true,
      type: String,
    },
  },
  emits: {
    drop(_: DragEvent) {
      return true;
    },
    isCollapsing() {
      return true;
    },
  },
  methods: {
    dragenter(event: DragEvent) {
      if (this.droppable) {
        event.preventDefault();
      }
    },
    dragover(event: DragEvent) {
      if (this.droppable) {
        event.preventDefault();
      }
    },
    isCollapsing() {
      this.$emit("isCollapsing");
    },
    onDrop(event: DragEvent) {
      this.$emit("drop", event);
    },
  },
});
</script>

<style scoped>
.card {
  min-height: 98%;
}
.isCollapsedTitle {
  margin-top: 30px;
  writing-mode: vertical-rl;
}
.compact-toggle {
  padding: 0 4px;
  position: absolute;
  top: 0px;
  left: 0px;
}
</style>
